<template>
	<view :style="'padding-top:'+nvaHeight+'px;'">
		<view class="navbox">
			<uni-nav-bar  color="#ffffff" rightWidth="150rpx" title="社情民意" @clickLeft="getBack" @clickRight="getChFn"  :background-color="backgroundColor" :border="false" statusBar='true' fixed="true">
				<block slot="left">
					<view class="topl">
						<image :src="backimg" ></image>
					</view>
				</block>
				<!-- <block slot="right">
					<view class="topr">
						<image :src="ccicoimg"></image>
						<view>提案查重</view>
					</view>
				</block> -->
			</uni-nav-bar>
			<view class="plr12 mt18">
				<view class="search flex0 mb10">
					<image :src="searchimg"></image>
					<input placeholder="输入关键字进行查询" v-model="title" @confirm="getConfirm"/>
				</view>
			</view>
			<view class="tablists flexc mb20">
				<block v-for="(ite,idx) in tabList" >
					<view  v-if="checkPermi([ite.limit])" @click="getTabFn(ite)" :class="{act:tabidx==ite.val}" :key="idx">{{ite.tit}}</view>
				</block>
				
			</view>
			<view style="height: 56rpx;"></view>
			<view class="lbtab flexc">
				<image :src="lbicoimg" class="limg"></image>
				<view class="lbtabs flexc">
					<view class="lbtabp">
						<picker mode="date" fields="year"  range-key='label'    @change='bindDateChangeb'>
							<view :class="year?'':'f16 co80'">{{year || "选择年份"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view>
					<view class="lbtabp">
						<picker  range-key='label' :value="ztlxidx" :range="ztlxlist"  @change='bindDateChangea'>
							<view :class="ztlx?'':'f16 co80'">{{ztlx || "主题类型"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view>
					<view class="lbtabp" v-if="tabidx=='xxsb'">
						<picker  range-key='label' :value="sfcyidx" :range="taztList"  @change='bindDateChangec'>
							<view :class="sfcy?'':'f16 co80'">{{sfcy || "是否采用"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view>
					<!-- <view class="lbtabp">
						<picker  range-key='label' :value="kwlxidx" :range="kwlxList"  @change='bindDateChanged'>
							<view :class="kwlx?'':'f16 co80'">{{kwlx || "刊物类型"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view>
					<view class="lbtabp">
						<picker  range-key='label' :value="psqkidx" :range="psList"  @change='bindDateChangee'>
							<view :class="psqk?'':'f16 co80'">{{psqk || "批示情况"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view> -->
					<view class="lbtabp" v-if="tabidx=='qb'||tabidx=='xxsb'">
						<picker  range-key='label' :value="tajdidx" :range="tajdlist"  @change='bindDateChangef'>
							<view :class="tajd?'':'f16 co80'">{{tajd || "办理状态"}}</view>
						</picker>
						<image :src="upimg" class="upimg"></image>
					</view>
				</view>
			</view>
		</view>
		<!-- 列表 -->
		<view class="mbox">
			<sqmy-info-list :datalist="list" :listtype="listtype" :wtdt="wtdt" :ztlxlist='ztlxlist' :tajdlist="tajdlist" :type='tabidx' @getDetail="getDetail"  @getTuiFn="getTuiFn"></sqmy-info-list>
		</view>
		<view v-if="checkPermi(['proposalInfo:info:add'])&&tabidx=='wdta'">
			<view style="height: 100rpx;"></view>
			<view class="fwbtns" @click="getAddCase">提交提案</view>
		</view>
		
		
		<!-- 弹窗 -->
		<pop-up :type='ptype' :blfsList="matterList" :blcdlist="blcdlist" @getFaFn="getFaFn" :mycdlist="mycdlist" :dataTree="deptTree" @getClose="getClose" @getupSubmit="getupSubmit"></pop-up>
	</view>
</template>

<script>
	import { checkPermi, checkRole } from "@/utils/permission"; // 权限判断函数
	import {getsqmyInfoListFn,getsqmyInfoisRecordFn,getsqmyInfoAssignFn,getsqmyReplyFn,
	getsqmyInfoShFn,getsqmyInfoIdeaFn,getsqmyInfozxIdeaFn,
	getInfourgeFn,getsqmyInfokeyPointFn,getsqmyInfooutstandingFn
	} from "@/api/mine/sqmyInfo.js"
	import popUp from "@/work/components/popup/popup.vue"
	import sqmyInfoList from "@/work/components/sqmyInfo/list.vue"
	import {getDictionaryFn} from "@/api/mine/register.js"
	import {getDeptTree} from"@/api/mine/mine.js"
	export default{
		components:{sqmyInfoList,popUp},
		data(){
			return{
				searchimg: require("@/work/static/images/search.png"),
				ccicoimg:require("@/work/static/images/ccico.png"),
				lbicoimg:require("@/work/static/images/lbico.png"),
				backimg:require("@/work/static/images/back.png"),
				upimg:require("@/work/static/images/up.png"),
				backgroundColor:"#1D64E2",
				tabidx:'qb',
				tabtype:'',//进度查询
				// {tit:'征集通知',val:0}, 提案催办 目前看所有
				tabList:[{tit:'全部',val:'qb',},{tit:'信息审核',jd:1,val:'xxsh',limit:'proposalInfo:info:isRecord'},{tit:'信息交办',jd:4,val:'xxjb',},
				{tit:'信息办理',jd:5,val:'xxbl',},{tit:'办结审核',jd:6,val:'bjsh',},
				{tit:'信息催办',val:'xxcb',},
				{tit:'信息上报',val:'xxsb',},{tit:'上网社情民意',val:'swsqmy',},{tit:'推荐优秀',val:'tjyx'},
				{tit:'推荐重点',val:'tjzd'}
				],
				// {tit:'开始日期',val:1},{tit:'结束日期',val:2},
				// "sqmyProgress":"提案进度(0：提交提案，1：提案审查，2：提案立案，3：提案交办，4：办理提案，5：提案反馈，6：办结审核，7：已办结） ",
				nvaHeight:44,
				talbList:[{},],
				taztList:[{label:'是',value:'0'},{label:'否',value:'1'}],
				psList:[{label:'已批示',value:'0'},{label:'未批示',value:'1'}],
				kwlxList:[{label:'社情民意',value:'0'},{label:'刊物类型',value:'1'}],
				ptype:'',//弹窗类型
				list:[],
				pageSize: 10,
				pageNum: 1,
				reachflag: true,
				wtdt:'',
				tajdlist:[],//提案进度
				listtype:'case',
				
				year:'',//提案时间
				title:'',
				deptTree:[],
				matterList:[],
				blcdlist:[],
				mycdlist:[],
				ztlxlist:[],//主题类型
				ztlx:"",//主题
				ztlxid:"",
				ztlxidx:'',
				sfcy:"",//采用
				sfcyid:"",
				sfcyidx:'',
				kwlx:"",//刊物类型
				kwlxid:"",
				kwlxidx:'',
				psqk:"",//批示情况
				psqkid:"",
				psqkidx:'',
				tajd:"",//办理状态
				tajdid:"",
				tajdidx:'',
				id:'',
				userId:this.$store.state.user.userId,
			}
		},
		onUnload(){
			uni.$off('refreshlist')
		},
		onLoad(e) {
			this.getDataFn()
			this.init()
			uni.$on('refreshlist', (e) => {
				this.getDataFn()
			})
		},
		mounted() {
			this.getHeightFn()
		},
		methods:{
			checkPermi, checkRole,
			// 提案状态
			init(){
				// 主题类型
				getDictionaryFn('sqmy_topic_type').then(res=>{
					if(res.code==200&&res.data.length){
						this.ztlxlist = res.data.map(v => {
							return {
								label: v.dictLabel,
								value: v.dictValue
							}
						})
					}
				})
				getDictionaryFn('proposal_progress').then(res=>{
					if(res.code==200&&res.data.length){
						this.tajdlist = res.data.map(v => {
							return {
								label: v.dictLabel,
								value: v.dictValue
							}
						})
					}
				})
				// 协办单位
				getDeptTree().then(res=>{
					if(res.code==200){
						this.deptTree=res.data
					}
				})
				// 办理方式
				getDictionaryFn('negotiation_mode').then(res=>{
					if(res.code==200&&res.data.length){
						this.matterList = res.data.map(v => {
							return {
								label: v.dictLabel,
								value: v.dictValue
							}
						})
					}
				})
				// 办理程度degree
				getDictionaryFn('degree').then(res=>{
					if(res.code==200&&res.data.length){
						this.blcdlist = res.data.map(v => {
							return {
								text: v.dictLabel,
								value: v.dictValue
							}
						})
					}
				})
				// 满意程度
				getDictionaryFn('member_satisfaction').then(res=>{
					if(res.code==200&&res.data.length){
						this.mycdlist = res.data.map(v => {
							return {
								text: v.dictLabel,
								value: v.dictValue
							}
						})
					}
				})
			},
			getConfirm(){
				this.pageNum=1;
				this.list=[];
				this.reachflag=true;
				this.getDataFn()
			},
			getFaFn(type,ptype){
				this.ptype='';
				if(ptype=='sqmy'){
					if(type=='new'){uni.removeStorageSync('sqmyList')}
					this.$tab.navigateTo('/work/pages/case/add?type='+type)		
				}	
			},
			getTuiFn(data){
				var sh=data.sh;
				this.id=data.id;
				var type=data.type;
				console.log(type,1)
				var that=this;
				if(type=='scfk'){
					if(sh==1){
						this.ptype=data.type;
					}else{
						var params={
							proposalId:data.id,
							isRecord:0,
						}
						getsqmyInfoisRecordFn(params).then(res=>{
							if(res.code==200){
								this.$toast("立案成功");
								setTimeout(function(){
									that.ptype='';
									that.pageNum=1;
									that.list=[];
									that.reachflag=true;
									that.getDataFn()
								},1200)
								
							}
						})
					}
				}else if(type=='lmta'){
					if(sh==2){
						this.ptype=data.type;
					}else{
						var params={
							proposalId:data.id,
							isAgree:1,
						}
						getUserverifyFn(params).then(res=>{
							if(res.code==200){
								this.$toast("确认联名提案成功");
								setTimeout(function(){
									that.ptype='';
									that.pageNum=1;
									that.list=[];
									that.reachflag=true;
									that.getDataFn()
								},1200)
								
							}
						})
					}
				}else{
					this.ptype=type
				}	
			},
			getupSubmit(e){
				var that=this;
				var type=this.ptype;
				if(type=='scfk'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyInfoisRecordFn(params).then(res=>{
						if(res.code==200){
							this.$toast("立案成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)
							
						}
					})
				}else if(type=='tajb'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyInfoAssignFn(params).then(res=>{
						if(res.code==200){
							this.$toast("提案办结成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)
						}
					})
				}else if(type=='dffk'||type=='dwdf'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyReplyFn(params).then(res=>{
						if(res.code==200){
							this.$toast("答复反馈成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)	
						}
					})
				}else if(type=='jbsh'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyInfoShFn(params).then(res=>{
						if(res.code==200){
							this.$toast("交办审核成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)	
						}
					})
				}else if(type=='wymyfk'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyInfoIdeaFn(params).then(res=>{
						if(res.code==200){
							this.$toast("提案办结成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)	
						}
					})
				}else if(type=='zxmyfk'){
					var params=JSON.parse(JSON.stringify(e))
					params.sqmyId=this.id
					getsqmyInfozxIdeaFn(params).then(res=>{
						if(res.code==200){
							this.$toast("提案办结成功");
							setTimeout(function(){
								that.ptype='';
								that.getDetail()
							},1200)	
						}
					})
				}else if(type=='tacb'){
					var params=JSON.parse(JSON.stringify(e))
					params.scoreId=this.id
					params.urgeType=2
					getInfourgeFn(params).then(res=>{
						if(res.code==200){
							this.$toast("提案办结成功");
							setTimeout(function(){
								that.ptype='';
								that.pageNum=1;
								that.list=[];
								that.reachflag=true;
								that.getDataFn()
							},1200)	
						}
					})
				}else if(type=='tjyx'){
					var params=JSON.parse(JSON.stringify(e))
					params.proposalId=this.id
					getsqmyInfooutstandingFn(params).then(res=>{
						if(res.code==200){
							this.$toast("推荐优秀成功");
							setTimeout(function(){
								that.ptype='';
								that.pageNum=1;
								that.list=[];
								that.reachflag=true;
								that.getDataFn()
							},1200)	
						}
					})
				}else if(type=='tjzd'){
					var params=JSON.parse(JSON.stringify(e))
					params.proposalId=this.id
					getsqmyInfokeyPointFn(params).then(res=>{
						if(res.code==200){
							this.$toast("推荐重点成功");
							setTimeout(function(){
								that.ptype='';
								that.pageNum=1;
								that.list=[];
								that.reachflag=true;
								that.getDataFn()
							},1200)	
						}
					})
				// }else if(type=='lmta'){
				// 	var params=JSON.parse(JSON.stringify(e))
				// 	var str='同意'
				// 	if(params.isAgree==2){
				// 		str="反对"
				// 	}
				// 	params.proposalId=this.id
				// 	getUserverifyFn(params).then(res=>{
				// 		if(res.code==200){
				// 			this.$toast(str+"成功");
				// 			setTimeout(function(){
				// 				that.ptype='';
				// 				that.pageNum=1;
				// 				that.list=[];
				// 				that.reachflag=true;
				// 				that.getDataFn()
				// 			},1200)	
				// 		}
				// 	})
				}
			},
			getAddCase(){
				if(uni.getStorageSync('tjtaList')){
					// var newObj=JSON.parse(JSON.stringify(uni.getStorageSync('tjtaList')))
					this.ptype='zcta'
				}else{
					this.$tab.navigateTo('/work/pages/case/add')
				}
			},
			getHeightFn(){
				var s=uni.getSystemInfoSync().statusBarHeight;
				let query = uni.createSelectorQuery().in(this);
					//需要给黄色区域设置一个id标识，在这里是demo
				query.select('.navbox').boundingClientRect(data => {
					this.nvaHeight =s? data.height:Number(data.height)-20//赋值，待会要用
				}).exec();
			},
			getClose(){
				this.ptype=""
			},
			getTabFn(ite){
				this.tabidx=ite.val;
				this.pageNum=1;
				this.list=[],
				this.reachflag=true;
				this.tabtype=ite.jd||"";
				this.getDataFn()
			},
			getBack(){
				uni.navigateBack({
					delta:1
				})
			},
			getrefreshData(){
				this.pageNum=1;
				this.list=[];
				this.reachflag=true;
				this.getDataFn()
			},
			bindDateChangea(e){
				var val=e.detail.value;
				this.ztlx=this.ztlxlist[val].label;
				this.ztlxid=this.ztlxlist[val].value;
				this.getrefreshData()
			},
			bindDateChangeb(e){
				var val=e.detail.value;
				this.year=val;
				this.getrefreshData()
			},
			bindDateChangec(e){
				var val=e.detail.value;
				this.sfcy=this.taztList[val].label;
				this.sfcyid=this.taztList[val].value;
				this.getrefreshData()
			},
			bindDateChanged(e){
				var val=e.detail.value;
				this.kwlx=this.kwlxList[val].label;
				this.kwlxid=this.kwlxList[val].value;
				this.getrefreshData()
			},
			bindDateChangee(e){
				var val=e.detail.value;
				this.psqk=this.psList[val].label;
				this.psqkid=this.psList[val].value;
				this.getrefreshData()
			},
			bindDateChangef(e){
				var val=e.detail.value;
				this.tajd=this.tajdlist[val].label;
				this.tajdid=this.tajdlist[val].value;
				this.getrefreshData()
			},
			getChFn(){
				this.$tab.navigateTo('/work/pages/case/tacheck')
			},
			
			getDetail(data){
				this.$tab.navigateTo('/work/pages/sqmyInfo/details?id='+data)	
			},
			getDataFn(){
				var tab=this.tabidx;
				var params={
					pageSize:this.pageSize,
					pageNum: this.pageNum,
				}
				if(this.tabtype){
					params.sqmyProgress=this.tabtype
				}
				if(this.title){
					params.title=this.title
				}
				if(this.year){//年份
					params.year=this.year
				}
				if(this.ztlx){//主题
					params.topicType=this.ztlxid
				}
				if(this.sfcy&&tab=='xxsb'){//采用
					params.isRecord=this.sfcyid
				}
				if(this.tajd&&(tab=='qb'||tab=='xxsb')){//办理状态
					params.sqmyProgress=this.tajdid
				}
				// if(this.kwlx){//刊物类型
				// 	params.topicType=this.ztlxid
				// }
				// if(this.psqk){批示情况
				// 	params.topicType=this.ztlxid
				// }
				
				if(tab=='tjyx'){
					params.isOutstanding="0"
				}else if(tab=='tjzd'){
					params.isKeyPoint="0"
				}else if(tab=='xxsb'){
					params.userId=this.userId
				}
				
				getsqmyInfoListFn(params).then(res=>{
					if(res.code==200){
						if (res.rows.length < this.pageSize) {
							this.reachflag = false
							this.wtdt = '到底了~';
						} else {
							var num = parseInt(res.rows.length) + parseInt(this.pageSize) * parseInt(this.pageNum -	1)
							if (num < res.total) {
								this.reachflag = true
								this.wtdt = '上拉加载更多'
							} else {
								this.reachflag = false
								this.wtdt = '到底了~';
							}
						}
						if (this.pageNum == 1) {
							this.list = res.rows;
						} else {
							this.list = this.list.concat(res.rows)
						}
					}else{
						this.$toast(res.msg)
					}
				}) 
				
				
			},
		}
	}
</script>

<style scoped lang="scss">
.navbox{position: fixed;left: 0;right: 0;top: 0;z-index: 4;background-color: $com-cd3;
	.topl{width: 60rpx;height: 60rpx;display: flex;align-items: center;justify-content: center;
		image{width: 40rpx;height: 30rpx;}
	}
	.topr{display: flex;align-items: center;
		image{width: 26rpx;height: 26rpx;margin-right: 12rpx;}
		view{font-weight: 500;font-size: 26rpx;color: #FFFFFF;}
	}
	.tablists{
		overflow: auto;flex-wrap: nowrap;
		view{font-weight: bold;font-size: 26rpx;color: #FFFFFF;position: relative;flex: 1 0 auto;padding: 22rpx 24rpx;margin-right: 6rpx;box-sizing: border-box;text-align: center;
			&:last-child{margin-right: 0;}
			&.act{font-size: 30rpx;
				&::after{content: '';width: 62rpx;height: 10rpx;background: #FFFFFF;border-radius: 4rpx;left: 50%;margin-left: -31rpx;bottom: 0rpx;position: absolute;}
			}
		}
	}
	.lbtab{height: 114rpx;background: #FFFFFF;border-radius: 30rpx;padding-left: 24rpx;position: absolute;left:24rpx;right: 24rpx;bottom: -58rpx;
		.limg{width: 40rpx;height: 34rpx;margin-right: 10rpx;flex:0 0 auto;}
		.lbtabs{overflow: auto;flex-wrap: nowrap;flex: 1;
			.lbtabp{display: flex;align-items: center;flex: 0 0 auto;margin-right: 24rpx;}
			.upimg{width: 18rpx;height: 10rpx;}
			
		}
	}
}
.mbox{padding:58rpx 24rpx 28rpx;}
.lbtabs /deep/ picker{padding: 0 18rpx;}
</style>